<?
/* $Id: function.inc.php 2591 2008-12-26 16:24:43Z vadim $ */

/** 
 * Init filed types, field name
 */
function InitVars () {
  global $field_types, $field_type_name, $type_of_edit, $type_of_edit_name, $type_of_error;
  
  $field_types = array(1 => 'i_type_string.gif',
                     2 => 'i_type_int.gif',
                     3 => 'i_type_text.gif',
                     4 => 'i_type_classificator.gif',
                     5 => 'i_type_bool.gif',
                     6 => 'i_type_file.gif',
                     7 => 'i_type_float.gif',
                     8 => 'i_type_date.gif',
                     9 => 'i_type_link.gif',
                     10 => 'i_type_multiclassificator.gif');
  
  $field_type_name = array(1 => CLASSIFICATOR_TYPEOFDATA_STRING,
                           2 => CLASSIFICATOR_TYPEOFDATA_INTEGER,
                           3 => CLASSIFICATOR_TYPEOFDATA_TEXTBOX,
                           4 => CLASSIFICATOR_TYPEOFDATA_LIST,
                           5 => CLASSIFICATOR_TYPEOFDATA_BOOLEAN,
                           6 => CLASSIFICATOR_TYPEOFDATA_FILE,
                           7 => CLASSIFICATOR_TYPEOFDATA_FLOAT,
                           8 => CLASSIFICATOR_TYPEOFDATA_DATETIME,
                           9 => CLASSIFICATOR_TYPEOFDATA_RELATION,
                           10 => CLASSIFICATOR_TYPEOFDATA_MULTILIST );
                           
  $type_of_edit = array(1 => 'i_field_access_all.gif',
                        2 => 'i_field_access_admin.gif',
                        3 => 'i_field_access_no.gif');

  $type_of_edit_name = array(1 => CLASSIFICATOR_TYPEOFEDIT_ALL,
                             2 => CLASSIFICATOR_TYPEOFDATA_ADMINS,
                             3 => CLASSIFICATOR_TYPEOFDATA_NOONE);
                             
  $type_of_error = array(  0=> CONTROL_FIELD_DB_ERROR,
                           1 => CONTROL_FIELD_NAME_ERROR,
                           2 => CONTROL_FIELD_ONE_RESERVED,
                           3 => CONTROL_FIELD_EXITS_ERROR,
                           4 => CONTROL_FIELD_FORMAT_ERROR);
  
  
  return;
}


/**
 * Insert(modify, drop) into Table (Message or Subdivision or Template or.. see SystemTable) field
 * @param int FieldID
 * @param int type operation: 1 - add, 2 - modify, 3 - drop
 * @param object $db
 */
function ColumnInMessage ($FieldID, $type, $db) {
  global $db;
  
  $query = "SELECT `Class_ID`, `Field_Name`, `TypeOfData_ID`, `NotNull`, `DoSearch`, `DefaultState`, `System_Table_ID` FROM `Field` WHERE `Field_ID`= '".$FieldID."'";
  $SelectField = $db->get_row($query); 
  
  $isSys = $SelectField->System_Table_ID;  #for short, ==0 - if Component Field 

  switch ($type) {
    case 1: $oper = "ADD";    break;
    case 2: $oper = "MODIFY"; break;
    case 3: $oper = "DROP";   break;
  }

  if (!$isSys && $SelectField->DoSearch) $db->query("ALTER TABLE `Message".$SelectField->Class_ID."` DROP INDEX `".$SelectField->Field_Name."`");
  
  $TableName = $isSys ? GetSystemTableName($SelectField->System_Table_ID) : "Message".$SelectField->Class_ID;
  
  $alter = "ALTER TABLE ".$TableName." ".$oper." ".$SelectField->Field_Name;

  if ($type==3) {
      $db->query($alter);
      return true;
  }

  $alter .= " ";

  switch ($SelectField->TypeOfData_ID) {
      case   1: $alter .= "char(255)"  ; break;
      case   2: $alter .= "int"        ; break;
      case   3: $alter .= "longtext"   ; break;
      case   4: $alter .= "int"        ; break;
      case   5: $alter .= "tinyint"    ; break;
      case   6: $alter .= "char(255)"  ; break;
      case   7: $alter .= "double"     ; break;
      case   8: $alter .= "datetime"   ; break;
      case   9: $alter .= "int"        ; break;
      case  10: $alter .= "text"       ; break;
  }

  switch  ( true ) {
  	case ($SelectField->DefaultState && $SelectField->TypeOfData_ID != 3 ):
    	$alter.= " NOT NULL DEFAULT '".$SelectField->DefaultState."'";
    	break;
    case $SelectField->NotNull :
    	$alter.= " NOT NULL";
    	break;
    default:	
    	$alter.= " NULL";
  }

  $db->query($alter);
  if ( $isSys ) return true;
  
  if ($SelectField->DoSearch && $SelectField->TypeOfData_ID!=3) {
  	$query = "ALTER TABLE `".$TableName."` ADD INDEX (`".$SelectField->FieldName."`)";
  	$db->query($query);
  }

  return true;
}



/**
 * Show field list
 *
 * @param int $Id - ClassID or SystemTableID
 * @param bool is flied in system table
 * @param bool show for component wizard
 * @return bool  true - if success
 */
function FieldList ($Id, $isSys = 0, $isWizard = 0) { 

  global $db;
  global $UI_CONFIG, $ADMIN_PATH, $ADMIN_TEMPLATE;
  global $field_types, $field_type_name, $type_of_edit, $type_of_edit_name;
  
  $Id += 0;
  if (!$Id) return false;
  
  $where = $isSys ? "`System_Table_ID`" : "`Class_ID`";
  $where .= "='".$Id."'";
  
  $query = "SELECT `Field_ID`, `Field_Name`, `Description`, `TypeOfData_ID`, `DoSearch`, `NotNull`, `TypeOfEdit_ID`, `Priority` 
            FROM `Field` 
            WHERE ".$where." 
            ORDER BY `Priority`";
 
  $Result = $db->get_results($query);

  if ( $countFields=$db->num_rows) {

		

		if (!$isWizard) print "<form method='post' action='index.php'>\n";
		?>
		<table border='0' cellpadding='0' cellspacing='0' width='100%'>
		  <tr>
		    <td bgcolor='#CCCCCC'>
          <table border='0' cellpadding='4' cellspacing='1' width='100%'>
            <tr>
              <td bgcolor='eeeeee'><font size='-2'><b>ID</td>
              <td bgcolor='eeeeee' width='20%'><font size='-2'><b><?=CONTROL_FIELD_LIST_NAME?></b></td>
              <td bgcolor='eeeeee' width='50%'><font size='-2'><b><?=CONTROL_FIELD_LIST_DESCRIPTION?></b></td>
              <td bgcolor='eeeeee' colspan='4' width='10%'><font size='-2'><b><?=CONTROL_CLASS_CLASS_OBJECTSLIST_SHOWOBJ_DOPL?></b></font></td>
              <td bgcolor='eeeeee' align='center'>
                <img width='16' height='16' src=<?=$ADMIN_PATH?>images/prior.gif alt='<?=CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_PRIORITY?>'>
              </td>
              <? if (!$isWizard ): ?>
              <td bgcolor=eeeeee align=center>
                <img src='<?=$ADMIN_TEMPLATE?>img/i_delete.gif' width='16' height='16' alt='<?=CONTROL_CONTENT_CATALOUGE_FUNCS_SHOWCATALOGUELIST_DELETE?>'></td>
              <? endif; ?>
            </tr>

		<?
    
		foreach ( $Result as $Row ) {
	    print "<tr>\n";
	    print "  <td bgcolor='#FFFFFF'><font size='-2'><b>".$Row->Field_ID."</b></td>\n";
	    if ($isWizard ) {
	      print "  <td bgcolor='#FFFFFF'>".$Row->Field_Name."</td>\n";
	    }
	    else {
	      print "  <td bgcolor='#FFFFFF'><a href='index.php?phase=4&amp;FieldID=".$Row->Field_ID."&amp;isSys=".$isSys."'>".$Row->Field_Name."</a></td>\n";
      }
	    print "  <td bgcolor='#FFFFFF'><font size='-2'>".$Row->Description."</td>\n";
	    print "  <td bgcolor='#FFFFFF'><img src='".$ADMIN_TEMPLATE."img/".$field_types[$Row->TypeOfData_ID]."' alt='".$field_type_name[$Row->TypeOfData_ID]."'></td>\n";
	    print "  <td bgcolor='#FFFFFF'><img src='".$ADMIN_TEMPLATE."img/i_field_search_".($Row->DoSearch?"on":"off").".gif' alt='".CONTROL_FIELD_ONE_INDEX."'</td>\n";
	    print "  <td bgcolor='#FFFFFF'><img src='".$ADMIN_TEMPLATE."img/i_field_notnull_".($Row->NotNull?"on":"off").".gif' alt='".CONTROL_FIELD_ONE_MUSTBE."'</td>\n";
	    print "  <td bgcolor='#FFFFFF'><img src='".$ADMIN_TEMPLATE."img/".$type_of_edit[$Row->TypeOfEdit_ID]."' alt='".$type_of_edit_name[$Row->TypeOfEdit_ID]."'</td>\n";
	    print "  <td align='center' bgcolor='#FFFFFF'>
	               <input type='text' name='priority[".$Row->Field_ID."]' value='".($Row->Priority?$Row->Priority:0)."' 
	                      size='3' class='s' maxlength='5' ".($isWizard ? "disabled":"").">
	             </td>\n";
	    if (!$isWizard)
	     print "  <td align='center' bgcolor='#FFFFFF'><input type='checkbox' name='Delete[]' value='".$Row->Field_ID."'></td>\n";
	    print "</tr>\n";
		}
    
		$name = $isSys ? "SystemTableID" : "ClassID";
    print "<input type='hidden' name='".$name."' value='".$Id."'>\n";
    print "<input type='hidden' name='isSys' value='".$isSys."'>\n";

		?>
          </table>
        </td>
      </tr>
    </table>
    <br>
	  <?
  } 
  else {
    nc_print_status(CONTROL_FIELD_LIST_NONE, 'info');
  }
  if( !$isWizard) {  
    if ($countFields) {
      $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                          "caption" => CONTROL_FIELD_LIST_CHANGE,
                                          "action" => "mainView.submitIframeForm()" );
    }
    $location = $isSys ? "systemfield" : "field";
    $UI_CONFIG->actionButtons[] = array("id" => "addClass",
                                        "caption" => CONTROL_FIELD_LIST_ADD,
                                        "action" => "urlDispatcher.load('".$location.".add(".$Id.")')",
                                        "align" => "left");
    if ($countFields) {
  	 ?>
         <input type='hidden' name='phase' value='6'>
  	     <input type='submit' class='hidden'>
       </form>
  	<?
    }
  }
  return true;
} #   --- End function FieldList --- 

#########################################
#        
#########################################

/**
 * Show form to edit field or create new
 *
 * @param int Field id, 0 - if new
 * @param int ClassId or SystemTableId, if 0 - edit field 
 * @param bool is flied in system table
 * @param string action
 * @param string form name
 * @param string form id
 * @param string Advanced elements
 * @return bool true
 */
function FieldForm ($FieldID, $Id, $isSys=0, $action = "index.php", $FormName = '', $FormID = '', $Additional = '') {
  global $db;
  global $UI_CONFIG;
  global $field_type_name, $type_of_edit_name;

  if ($FieldID) {
    $query = "SELECT `Field_Name`, `Description`, `TypeOfData_ID`, `Format`, `NotNull`, `Priority`, `DoSearch`, 
                     `Inheritance`, `DefaultState`, `TypeOfEdit_ID` 
              FROM `Field` 
              WHERE `Field_ID`='".$FieldID."'";
    $Array = $db->get_row($query, ARRAY_A) ;
  } 
  else {
    $Array = $_POST;
    $where = $isSys ? "`System_Table_ID`" : "`Class_ID`";
    $where .= "='".$Id."'";
    
    if (!$Array["Priority"]) {
      $query = "SELECT (Priority+1) FROM `Field` WHERE ".$where." ORDER BY `Priority` DESC LIMIT 1";
      $res = $db->get_var($query);
      if (!is_null($res)) $Array["Priority"] = $res;
    }
  }
  
  print "<form method='post' action='".$action."' name='".$FormName."' id='".$FormID."'><font color='gray'>";

  if ($FieldID) {
    print CONTROL_FIELD_LIST_NAME.": <b>".$Array["Field_Name"]."</b><br><br>";
  } else {
    print CONTROL_FIELD_LIST_NAMELAT.":<br><input type='text' name='FieldName' size='50' maxlength='64' value='".htmlspecialchars($Array["Field_Name"])."'><br><br>";
  }

  print CONTROL_FIELD_LIST_DESCRIPTION.":<br><input type='text' name='Description' size='50' maxlength='64' value='".htmlspecialchars($Array["Description"])."'><br><br>";

  print CONTROL_FIELD_ONE_FTYPE.":<br><select name='TypeOfData_ID'>";
  for ( $i = 1; $i <= count($field_type_name); $i++ ) {
    //   "  .."     
    if ( $isSys && ($i === 9) ) continue;
    print "<option ".($Array["TypeOfData_ID"]==$i?"selected":"")." value='".$i."'>".$i.": ".$field_type_name[$i]."</option>\n";
  }
  print "</select><br><br>";

  print CONTROL_FIELD_ONE_FORMAT.":<br><input type='text' name='Format' size='50' maxlength='255' value='".htmlspecialchars($Array["Format"], ENT_QUOTES)."'><br><br>";

  print "<input id='notn' type='checkbox' ".($Array["NotNull"]?"checked":"")." name='NotNull' value='1'> <label for='notn'>".CONTROL_FIELD_ONE_MUSTBE."</label><br>"; 
  if ( $isSys) {
     print "<input id='inhr' type='checkbox' ".($Array["Inheritance"]?"checked":"")." name='Inheritance' value='1'>\n"; 
     print "<label for='inhr'>".CONTROL_FIELD_ONE_INHERITANCE."</label>\n<br><br>\n";
  }
  else {
    print "<input id='dosr' type='checkbox' ".($Array["DoSearch"]?"checked":"")." name='DoSearch' value='1'>\n";
    print "<label for='dosr'>".CONTROL_FIELD_ONE_INDEX."</label>\n<br><br>\n";
  }

  print CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_PRIORITY.": <input type='text' name='Priority' size='3' maxlength='5' value='".($Array["Priority"]+0)."'><br><br>";

  print CONTROL_FIELD_ONE_DEFAULT."*:<br>";
  print "<input type='text' name='DefaultState' size='50' maxlength='255' value='".htmlspecialchars($Array["DefaultState"])."'>\n";
  print "<br>* ".CONTROL_FIELD_ONE_DEFAULT_NOTE.".<br><br>\n";

  print "<table border='0' cellpadding='6' cellspacing='0' width='100%'>\n";
  print "<tr><td valign='top' width='30%'><font color='gray'>".CONTROL_FIELD_ONE_ACCESS.":</td><td>\n";

  if (!$Array["TypeOfEdit_ID"]) $Array["TypeOfEdit_ID"] = 1;
  
  for ($i = 1; $i <= count($type_of_edit_name); $i++)  {
    print "<input type='radio' name='TypeOfEdit_ID' ";
    if ($Array["TypeOfEdit_ID"] == $i) print "checked ";
    print "value='".$i."' id='mod".$i."'>\n<label for='mod".$i."'>".$type_of_edit_name[$i]."</label>\n<br>\n";  
  }
  
  ;
  
  print "</select></td></tr>\n\n";
  print "</table>\n";

  if (!$FieldID) {
    $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                        "caption" => CONTROL_FIELD_LIST_ADD,
                                        "action" => "mainView.submitIframeForm('".$FormID."')");
  } else {
    $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                        "caption" => CONTROL_CONTENT_CATALOUGE_FUNCS_CATALOGUEFORM_SAVE,
                                        "action" => "mainView.submitIframeForm('".$FormID."')");
  }

  $name = $isSys ? "SystemTableID" : "ClassID";
  
  if ($Id) {
    print "<input type='hidden' name='".$name."' value='".$Id."'>\n";
    print "<input type='hidden' name='phase' value='3'>\n";
  } 
  else {
    if ($isSys) print "<input type='hidden' name='SystemTableID' value='".$Id."'>\n";
    print "<input type='hidden' name='FieldID' value='".$FieldID."'>\n";
    print "<input type='hidden' name='phase' value='5'>\n";
  }
  print $Additional;
  print "<input type='hidden' name='isSys' value='".$isSys."'>\n";
  print "<input type='submit' class='hidden'>\n";
  print "</form>\n";

  return true;
}

/**
 * Insert into DB properties of flied
 *
 * @param bool is flied in system table 
 * @return int field id ,0 -  unknown error, -1 = incorrect field name, -2 = field name is mysql_keyword, -3 = field already exits 
 *                                           -4 = incorrect field format
 * 
 */
function FieldCompleted () {
  global $db; 
  global $ClassID, $SystemTableID;
  global $Inheritance, $DoSearch; 
  global $FieldID, $FieldName, $Description, $TypeOfData_ID, $TypeOfEdit_ID, $Format, $NotNull, $Priority, $DefaultState;
  global $isSys;

  $TableName = $isSys ? GetSystemTableName ($SystemTableID) : "Message".$ClassID;
  
  $NotNull += 0;
  $DoSearch += 0;
  $Inheritance += 0;
  $Priority += 0;
  
  $FieldName = str_replace(' ','', $FieldName);
  if ( !isCorrectFormat($Format, $TypeOfData_ID ) ) return -4;
  switch (1) {
    case ( count($db->get_results("SHOW FIELDS FROM `".$TableName."` LIKE '".$FieldName."'")) ):   //check for exits
      return -3;    
    //case ( !$FieldName  || preg_match("/[^a-zA-Z0-9_]/", $FieldName) ):
    //  return -1;
    case ( nc_is_mysql_keyword($FieldName) ):                                                   // check for reserved sql words
      return -2;
  }
    
  // Add new field
  if ( !$FieldID ) {      
    $fl1 = $isSys ? "`System_Table_ID`" : "`Class_ID`";
    $fl2 = $isSys ? "`Inheritance`" : "`DoSearch`";
    $insert_flied = "`Field` (".$fl1.", ".$fl2.", `Field_Name`,`Description`,`TypeOfData_ID`,`Format`,`NotNull`,`Priority`,`DefaultState`,`TypeOfEdit_ID`)";
    $value = " VALUES ('";
    $value .= $isSys ? $SystemTableID."','".$Inheritance : $ClassID."','".$DoSearch;
    $value .= "','".$FieldName."','".$Description."',".$TypeOfData_ID.",'".$Format."',".$NotNull.",".$Priority.",'".$DefaultState."','".$TypeOfEdit_ID."')";
    $query = "INSERT INTO ".$insert_flied.$value; 
    
    if ( !$FieldName  || preg_match("/[^a-zA-Z0-9_]/", $FieldName) ) return -1;
    if ($db->query($query) ) { 
      $CurrentFieldID = $db->insert_id;
      ColumnInMessage ($CurrentFieldID, 1, $db);
    }
  
    return $CurrentFieldID;
  }
  // Update field
  else { 
    $query = "UPDATE `Field` SET `Description`='".$Description."',`TypeOfData_ID`='".$TypeOfData_ID."',`Format`='".$Format."',`NotNull`='".$NotNull;
    $query .= "',`Priority`='".$Priority."',`DefaultState`='".$DefaultState."',`TypeOfEdit_ID`='".$TypeOfEdit_ID."'";
    $query .= $isSys ? ", `Inheritance`='".$Inheritance."'" : ", `DoSearch`='".$DoSearch."'"; 
    $query .= " WHERE `Field_ID`='".$FieldID."'";
   
    if ($db->query($query)) ColumnInMessage ($FieldID, 2, $db);

    return $FieldID;
  }
  
  return 0; 
}


/**
 * Update priority
 *
 * @param array priority
 * @return bool
 */
function UpdateFieldPriority($priority) {
	global $db;

	if ( is_array($priority) && !empty($priority) ) {
		foreach($priority AS $key => $val) {
			$db->query("UPDATE `Field` SET `Priority` = '".(int)$val."' WHERE `Field_ID` = '".(int)$key."'");
		}
	}

	return true; 
}

/**
 * Confirm to flied delete
 *
 * @param array fields
 * @param int Id - ClassId or SystemTableID
 * @param bool is flied in system table
 * @return empty
 */
function ConfirmFieldsRemoval($fields, $Id, $isSys = 0) {
  
  global $db, $UI_CONFIG;
  global $priority;
 
  $field_array = $db->get_results("SELECT `Field_ID`, `Field_Name`, `Description`, `TypeOfData_ID` FROM `Field` WHERE Field_ID IN (".join(',', $fields).")", ARRAY_A);

  if ($db->num_rows > 1) {
    nc_print_status(CONTROL_FIELD_MSG_CONFIRM_REMOVAL_MANY, 'info');
  } else {
    nc_print_status(CONTROL_FIELD_MSG_CONFIRM_REMOVAL_ONE, 'info');
  }
  
  $name = $isSys ? "SystemTableID" : "ClassID";
  
  print "<form method='post' action='index.php'>\n";
  print "<input type='hidden' name='phase' value='7'>\n";
  print "<input type='hidden' name='".$name."' value='".$Id."'>\n";
  print "<input type='hidden' name='isSys' value='".$isSys."'>\n";
  
  print "<ul>\n";
  foreach ((array)$field_array as $field) {
    print "  <li>".$field['Field_Name']." (".$field['Description'].")<input type='hidden' name='Delete[]' value='".$field['Field_ID']."'>";
  }
  print "</ul>\n";
  
  if ($priority) foreach ($priority as $key => $val) echo "<input type='hidden' name='priority[".$key."]' value='".$val."'>\n";
  print "</form>\n";
  
  $UI_CONFIG->actionButtons[] = array("id" => "submit",
                                      "caption" => CONTROL_FIELD_CONFIRM_REMOVAL,
                                      "action" => "mainView.submitIframeForm()");
  return;
}

/**
 * Delete fields
 *
 * @param array $fields
 * @return int count deleted fields
 */
function DeleteFields($fields) {
  global $db, $UI_CONFIG;
  // start up value
  $fields_to_delete = array();
  // if no array
  if ( empty($fields) ) return 0;
  //
  $fields_data = $db->get_results("SELECT `Field_ID`, `System_Table_ID` FROM `Field`
    WHERE `Field_ID` IN (".join(", ", $fields).")", ARRAY_A);
  // walk
  foreach ($fields_data as $field) {
    if ( ColumnInMessage($field['Field_ID'], 3, $db) ) {
      $fields_to_delete[] = intval($field['Field_ID']);
      $UI_CONFIG->treeChanges['deleteNode'][] = ($field['System_Table_ID'] ? "system" : "")."field-".$field['Field_ID'];
    }
  }
  // delete fields from base
  if ( !empty($fields_to_delete) ) {
    // delete fields files
    DeleteFieldsFiles($fields_to_delete);
    // delete fields from base
    $db->query("DELETE FROM `Field` WHERE `Field_ID` IN (".join(", ", $fields_to_delete).")");
    return $db->rows_affected;
  }
  // return 0 if no fields deleted from base
  return 0;
}

function DeleteFieldsFiles ($fields) {
  global $db, $FILES_FOLDER;
  // set as array
  $fields = (array)$fields;
  $file_fields_to_delete = array();
  // validate for security reason
  $fields = array_map("intval", $fields);
  // return if array is empty
  if ( empty($fields) ) return 0;
  // get files info to delete
  $files_to_delete = $db->get_results("SELECT ft.`Field_ID`, ft.`Virt_Name`, ft.`File_Path`, fl.`System_Table_ID` FROM `Filetable` AS ft
    LEFT JOIN `Field` as fl ON ft.`Field_ID` = fl.`Field_ID`
    WHERE ft.`Field_ID` IN (".join(", ", $fields).") AND fl.`TypeOfData_ID` = 6", ARRAY_A);
  
  if ( empty($files_to_delete) ) return 0;
  
  foreach ($files_to_delete AS $_file_to_delete) {
    // set full path to file
    $file_to_delete_path = $FILES_FOLDER.$_file_to_delete['File_Path'].$_file_to_delete['Virt_Name'];
    // try to delete file from disk
    if ( is_writable($file_to_delete_path) ) {
      @unlink($file_to_delete_path);
      $file_fields_to_delete[] = $_file_to_delete['Field_ID'];
    }
  }
  // drop rows form `Filetable` table
  if ( !empty($file_fields_to_delete) ) {
    $db->query("DELETE FROM `Filetable` WHERE `Field_ID` IN (".join(", ", $file_fields_to_delete).")");
    return $db->rows_affected;
  }
  // return 0 if no files deleted from base
  return 0;
}

/** Checking - correct field format 
 *@param Format
 *@param Date type
 *@return bool, true - if correct
*/
function isCorrectFormat ($format, $id ) {
  switch ( $id ) {
    case 10: //MultuSelect
      return ereg("^[a-zA-Z0-9]+((:)((select(:[0-9]+)?)|(checkbox)))?$", $format);
      break;
    default: //     
      return true;
  }
}
###############################################################################


/**
 * Check, is param is mysql keyword
 *
 * @param string Field Name
 * @return bool true - if keyword
 */
function nc_is_mysql_keyword ($FieldName) {
   return in_array(strtolower($FieldName), preg_split("/\s+/",
                 "accessible add all alter analyze and as asc asensitive 
                  before between bigint binary blob both by call cascade 
                  case change char character check collate column condition connection 
                  constraint continue convert create cross current_date 
                  current_time current_timestamp current_user 
                  cursor database databases day_hour day_microsecond day_minute 
                  day_second dec decimal declare default delayed delete desc describe 
                  deterministic distinct distinctrow div double drop dual each else 
                  elseif enclosed escaped exists exit explain false fetch float 
                  float4 float8 for force foreign from fulltext goto grant 
                  group having high_priority hour_microsecond hour_minute hour_second 
                  if ignore in index infile inner inout insensitive insert 
                  int int1 int2 int3 int4 int8 integer interval into is iterate join 
                  key keys kill label leading leave left like limit linear lines load 
                  localtime localtimestamp lock long longblob longtext 
                  loop low_priority match mediumblob mediumint mediumtext 
                  middleint minute_microsecond minute_second mod modifies natural 
                  not no_write_to_binlog null numeric on optimize 
                  option optionally or order out outer outfile precision primary 
                  procedure purge range read reads read_only read_write real references 
                  regexp release rename repeat replace require restrict return revoke 
                  right rlike schema schemas second_microsecond select sensitive separator set 
                  show smallint spatial specific sql sqlexception sqlstate sqlwarning sql_big_result 
                  sql_calc_found_rows sql_small_result ssl starting straight_join table 
                  terminated then tinyblob tinyint tinytext title to trailing trigger true 
                  undo union unique unlock unsigned update upgrade usage use 
                  using utc_date utc_time utc_timestamp values varbinary 
                  varchar varcharacter varying when where while with write x509 
                  xor year_month zerofill"));     
}


class ui_config_field extends ui_config {
  
  private $_location;

  function ui_config_field($active_tab = 'edit', $field_id, $id, $is_sys) {

    global $db;
    
    $this->_location = $is_sys ? "systemfield" : "field";
    $this->headerImage = 'i_folder_big.gif';
    
    switch ($active_tab) {
      case 'add':
        $this->tabs = array(
		                    array('id' => 'add',
	                            'caption' => CONTROL_FIELD_ADDING,
	                            'location' => $this->_location.".add(".$id.")")
		                  );
	      $this->headerText = $is_sys ? constant($db->get_var("SELECT `System_Table_Rus_Name` FROM `System_Table` WHERE `System_Table_ID` = '".$id."'")) :
	                                    $db->get_var("SELECT `Class_Name` FROM `Class` WHERE `Class_ID` = '".$id."'");
	     
	      break;  
      case 'edit':
        $this->tabs = array(
		                    array('id' => 'edit',
	                            'caption' => CONTROL_FIELD_EDITING,
	                            'location' => $this->_location.".edit(".$field_id.")")
		                  );
	      $this->headerText = $db->get_var("SELECT `Description` FROM `Field` WHERE `Field_ID` = '".$field_id."'");
        $this->treeSelectedNode = $this->_location."field-{$field_id}";
        break;
      case 'delete':
        $this->tabs = array(
		                 array('id' => 'delete',
	                           'caption' => CONTROL_FIELD_DELETING,
	                           'location' => $this->_location.".delete(".$id.")")
		          );
	     $this->headerText = $is_sys ? constant($db->get_var("SELECT `System_Table_Rus_Name` FROM `System_Table` WHERE `System_Table_ID` = '".$id."'")) :
	                                   $db->get_var("SELECT `Class_Name` FROM `Class` WHERE `Class_ID` = '".$id."'");
		   $this->treeSelectedNode = $is_sys ? "systemclass-{".$system_class_id."}" : "dataclass-{".$class_id."}";
	    
       break;
    }

    $this->activeTab = $active_tab;
    $this->treeMode = 'developer';
  }
  
  function updateTreeFieldNode($field_id, $field_type) {
    global $field_types;
  
    $this->treeChanges['updateNode'][] = array("nodeId" => $this->_location."-".$field_id,
                                               "image" => $field_types[$field_type]);
    return;                               
  }

} #end class ui_config_field




?>